=begin
#SSRF Forwarder

#This is an API that forwards request on behalf of other services.

The version of the OpenAPI document: 1.0.0-oas3-oas3-oas3
Contact: jheath@chanzuckerberg.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.2.0

=end

require 'date'
require 'time'

module OpenapiClient
  class Request
    # the destination host of the request to be made
    attr_accessor :host

    attr_accessor :method

    # boolean to indicate if the request should be made over HTTPS or not; default is secure
    attr_accessor :secure

    # any custom headers that should also be forwarded with the request
    attr_accessor :headers

    # a timeout length in seconds for the HTTP request to return; default is 10 seconds
    attr_accessor :timeout

    # a JSON object whose key/value pairs will be mapped to URL query parameters
    attr_accessor :params

    # a string representing the HTTP request or response body
    attr_accessor :body

    # any sensitive keys that are used in URL parameters or in the HTTP body; keys marked as sensitive will be automatically scubbed
    attr_accessor :sensitive

    attr_accessor :content_type

    attr_accessor :redirect

    # the path in the URL from the host; query parameters should not be included here
    attr_accessor :path

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'host' => :'host',
        :'method' => :'method',
        :'secure' => :'secure',
        :'headers' => :'headers',
        :'timeout' => :'timeout',
        :'params' => :'params',
        :'body' => :'body',
        :'sensitive' => :'sensitive',
        :'content_type' => :'content_type',
        :'redirect' => :'redirect',
        :'path' => :'path'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'host' => :'String',
        :'method' => :'Method',
        :'secure' => :'Boolean',
        :'headers' => :'Object',
        :'timeout' => :'Integer',
        :'params' => :'Object',
        :'body' => :'String',
        :'sensitive' => :'Array<String>',
        :'content_type' => :'ContentType',
        :'redirect' => :'Redirect',
        :'path' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `OpenapiClient::Request` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `OpenapiClient::Request`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'host')
        self.host = attributes[:'host']
      end

      if attributes.key?(:'method')
        self.method = attributes[:'method']
      else
        self.method = 'GET'
      end

      if attributes.key?(:'secure')
        self.secure = attributes[:'secure']
      else
        self.secure = true
      end

      if attributes.key?(:'headers')
        self.headers = attributes[:'headers']
      end

      if attributes.key?(:'timeout')
        self.timeout = attributes[:'timeout']
      else
        self.timeout = 10
      end

      if attributes.key?(:'params')
        self.params = attributes[:'params']
      end

      if attributes.key?(:'body')
        self.body = attributes[:'body']
      else
        self.body = ''
      end

      if attributes.key?(:'sensitive')
        if (value = attributes[:'sensitive']).is_a?(Array)
          self.sensitive = value
        end
      end

      if attributes.key?(:'content_type')
        self.content_type = attributes[:'content_type']
      else
        self.content_type = 'application/json'
      end

      if attributes.key?(:'redirect')
        self.redirect = attributes[:'redirect']
      end

      if attributes.key?(:'path')
        self.path = attributes[:'path']
      else
        self.path = ''
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @host.nil?
        invalid_properties.push('invalid value for "host", host cannot be nil.')
      end

      if @method.nil?
        invalid_properties.push('invalid value for "method", method cannot be nil.')
      end

      if @secure.nil?
        invalid_properties.push('invalid value for "secure", secure cannot be nil.')
      end

      if @headers.nil?
        invalid_properties.push('invalid value for "headers", headers cannot be nil.')
      end

      if @timeout.nil?
        invalid_properties.push('invalid value for "timeout", timeout cannot be nil.')
      end

      if @params.nil?
        invalid_properties.push('invalid value for "params", params cannot be nil.')
      end

      if @body.nil?
        invalid_properties.push('invalid value for "body", body cannot be nil.')
      end

      if @sensitive.nil?
        invalid_properties.push('invalid value for "sensitive", sensitive cannot be nil.')
      end

      if @content_type.nil?
        invalid_properties.push('invalid value for "content_type", content_type cannot be nil.')
      end

      if @path.nil?
        invalid_properties.push('invalid value for "path", path cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @host.nil?
      return false if @method.nil?
      return false if @secure.nil?
      return false if @headers.nil?
      return false if @timeout.nil?
      return false if @params.nil?
      return false if @body.nil?
      return false if @sensitive.nil?
      return false if @content_type.nil?
      return false if @path.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          host == o.host &&
          method == o.method &&
          secure == o.secure &&
          headers == o.headers &&
          timeout == o.timeout &&
          params == o.params &&
          body == o.body &&
          sensitive == o.sensitive &&
          content_type == o.content_type &&
          redirect == o.redirect &&
          path == o.path
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [host, method, secure, headers, timeout, params, body, sensitive, content_type, redirect, path].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = OpenapiClient.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
